/*******************************************************\
* Copyright (C) 2006, ApS s.r.o Brno, AllRightsReserved *
\*******************************************************/

#ifndef CODASIP_GEN_FRAMEINFO_H
#define CODASIP_GEN_FRAMEINFO_H

#include "Codasip.h"
#include "llvm/Target/TargetFrameLowering.h"

namespace llvm {

class CodasipGenFrameLowering: public TargetFrameLowering
{
  const TargetInstrInfo &TII;

public:
  explicit CodasipGenFrameLowering(const CodasipTargetMachine &tm);

  void emitPrologue(MachineFunction &MF) const;
  void emitEpilogue(MachineFunction &MF, MachineBasicBlock &MBB) const;
  bool hasFP(const MachineFunction &MF) const;
};

} // End llvm namespace

#endif
